/*****************************************************************************
* mn10200-wii.h - mostly external addresses, functions, and such
* Copyright (C) 2006 (April, 4th) OpenWii (admin@openwii.org)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
*****************************************************************************/

#ifndef MN10200_WII
#define MN10200_WII

extern void taskWait(unsigned short, void *, unsigned short); //formallu sub_94f61
extern void sub_94ec3(unsigned short, void *, unsigned short);
extern short memcpy(unsigned short len, unsigned char *src); //dst passed as a0, damn diff calling conventions
extern short memcmp(unsigned short len, unsigned char *ptr1); //ptr2 is passed as a0 again,

extern void cmd0Handler();
extern void sub_83e13();
extern void sub_83e03();
extern void sub_952b0(unsigned short,void *);
extern void sub_9241e();	
extern void sub_838dc();
extern unsigned short sub_89e6c();

extern unsigned char cmdDiBytes[]; //_loc_8308=0x8308; cmdDiByte*
extern unsigned short loc_8330; //_loc_8330=0x8330;
extern unsigned short loc_8332; //_loc_8332=0x8332;
extern unsigned short cmd0Flags; //_loc_8334=0x8334; cmd0Flags
extern unsigned short loc_8336; //_loc_8336=0x8336;
extern unsigned char loc_8346; //_loc_8346=0x8346; * 
extern unsigned char loc_8368; //_loc_8368=0x8368; *
extern unsigned char loc_8369; //_loc8369=0x8369; *
extern unsigned char loc_838c; //_loc838c=0x838c; *
extern unsigned short loc_85b8; //_loc85b8=0x85B8;
extern unsigned char loc_40030f; //_loc40030f=0x40030F; * 
extern unsigned short loc_8332;

extern unsigned char emuFlag; //0x8598
extern unsigned short mediaFlag; //0x8576
extern unsigned char loginStatus; //0x40ba06
extern unsigned short otherFlag;

extern unsigned char maxSectorsRaw[2];
extern unsigned long int discSize1;
extern unsigned long int discSize2;
extern unsigned long int discSize3;
extern unsigned long int discSize4;

extern unsigned short ourRegion;
extern unsigned short ourBoot;
extern unsigned short ourSpeed;
extern unsigned short OurAudio;
extern char temp_buf[2000];

extern void *origRetAddr; //loop's orig return address
extern void *stackRetAddr; //the current return address

/*10:37 <@Erant> Anyway, anything above 0xD00000 isn't accessable directly from the 
               proc, so what you do is write <your address - 0xD00000> to 0x40006C, 
               and it'll mirror that address in 0x430000
*/
extern void * volatile memmap; 
extern unsigned char membuf[]; //
/*flag to tell loop we have a backup disc*/
extern unsigned char backup;
/*this function is in loop.c*/
extern void startBigLoop(void);

#define JAP_R 0x00 //is JAP
#define USA_R 0x01 //is USA
#define PAL_R 0x02 //is PAL

//Misc DI Commands
#define DI_READSECTOR	0xa8	//read sector
#define DI_SETREGION	0xe9	//we made this one up....

#endif
