/*
* backendJackd.c - LoginState Stuff
*
* Copyright (C) 2006 (April, 4th) OpenWii (admin@openwii.org)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
*/
#include "mn10200-wii.h"

void doStuff(void);

unsigned char backup;

/*Put this at the beginning of the file by using the start symbol.*/
asm("start: 
	jsr _doStuff
	jmp _beJackRetAddr");

//This is called at loginstate 0x7f
void doStuff(void) {
	register unsigned long int maxSectors asm("d2") ;
	backup=0;
	// Media flag settings
	// 8cm is mediaflag & 0x40
	if((mediaFlag == 0x1018) || (mediaFlag == 0x0818) || (mediaFlag == 0x200c) || (mediaFlag == 0x05018)) { //check if backup disc
		mediaFlag=0x8828;	//if so set media flags and emu flag
		emuFlag=0x4;
		maxSectors=(maxSectorsRaw[2]) | 
			(maxSectorsRaw[1]<<8) | 
			((unsigned long int)maxSectorsRaw[0]<<16);
		discSize1=maxSectors;
		discSize2=maxSectors;
		discSize3=maxSectors;
		discSize4=maxSectors;	//also fill in max sector info
		backup=1;		//set backup flag so we know to continue changing media flags later on
	}
	stackRetAddr=&startBigLoop;	//go ahead and jack the return address of main loop now plz
}
