/**************************************************************
* loop.c - Main Loop Relocate
* Copyright (C) 2006 (April, 4th) OpenWii (admin@openwii.org)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* ToDo: Create todo list.
***************************************************************/
#include "mn10200-wii.h"

typedef unsigned char regData_t[10];

// Buffer to hold firmware from GC ;)
// Trick #1
//char temp_buf[2000];

//counter
int x = 0;

const regData_t regData[]={
	{0x00, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80}, //ntsc-j (japan)
	{0x10, 0x00, 0x00, 0x00, 0x10, 0xE0, 0x04, 0x00, 0x00, 0x00}, //ntsc (usa)
	{0x00, 0x80, 0x80, 0x06, 0x03, 0x03, 0x04, 0x03, 0x07, 0x00} //PAL (europe)
};



void startBigLoop(void) __attribute__ ((noreturn));

void startBigLoop(void)
{
	register unsigned char storedCmdDiByte asm ("d2") = 0;
	goto OpenWiiEntry;
	while(1)
	{
		// if discLogin detected a backup disc continue setting media flags
//		if((backup==1) && (loginStatus>=0xd0)) {
		if(backup==1) {
			mediaFlag=0x8838;
			backup++;
		}
		if((backup==2) && (loginStatus >= 0xF4)) {
			otherFlag=0xbd01 | ((ourRegion&0x40)<<9);	//finally setup speed  
									//seems 3d00 eventually sets itself to bd01
			backup++;
		}
		if( (loc_8336 == 0)  ||  (loc_85b8 != 0))
		{
			cmd0Flags = 0;
			asm("mov _cmd0Flags, a0");
			taskWait(0x1, (void*)0x00FFFF, 0x1);
OpenWiiEntry:
			//region freeness is here
			if(((ourRegion&0x4)==0) && (cmdDiBytes[0]==DI_READSECTOR) && (cmdDiBytes[4]==0x00)) { //check if dicommand was a read
				if((cmdDiBytes[5]==0x1) && (cmdDiBytes[6]==0x38) && (cmdDiBytes[7]==00)) { //wii region sector
					memmap=(void*)0x21D3C0;
					if(membuf[0xf]!=(ourRegion&0x3)) {
						membuf[0xf]=(ourRegion&0x3);
						asm("mov _membuf+0x1c,a0");
						memcpy(sizeof(regData_t),(unsigned char *)regData[ourRegion&0x3]);
					}
					memmap=0;
				}
				if((cmdDiBytes[5]==0x0) && (cmdDiBytes[6]==0x01) && (cmdDiBytes[7]==0x10)) { //gc region sector
					memmap=(void*)0x20f660;
					membuf[0x7]=ourRegion;
					memmap=0;
				}
			}
			// Bootloader shit
			// Add bytes to buffer - start
                        if (cmdDiBytes[0] == 0x69)
                        {
                                temp_buf[x] = cmdDiBytes[3];
                                x++;
                        }
			//check for a openwii setup di_command
			if(cmdDiBytes[0]==DI_SETREGION) 
			{

			 // Region Setup
                         if ((cmdDiBytes[3] == 0x01) || (cmdDiBytes[3] == 0x02) || (cmdDiBytes[3] == 0x03) || (cmdDiBytes[3] == 0x04))
                         {
                                 ourRegion = cmdDiBytes[3] | 0xa500; //Set Region
                         }
			 //Boot Loader setup
			if (cmdDiBytes[3] == 0x09) 
			{	
				// reset X
				//x = 0;
				ourBoot = cmdDiBytes[3];

			}
			}
			if( (cmd0Flags & 0x532) != 0x20)
			{
				cmd0Handler();
			}else{
				if((loc_8369 == 0) || ((loc_85b8 != 0x4) && (loc_85b8 != 0x3)))
				{
					loc_8369 = 0;
					cmd0Handler();
				}else{
					storedCmdDiByte = cmdDiBytes[0];
					if(loc_40030f & 0x10)
					{
						loc_8330 = 0x800;
						loc_8332 = 0x4;
						sub_83e13();
					}
					sub_83e03();
					loc_8368 &= 0xfe;
					if( (loc_8346 != 0x0) && (loc_8346 != 0x13) )
					{
						loc_85b8 = 0x1;	
					}else{
						loc_85b8 = 0x0;
					}
					loc_8369=0;
					sub_952b0(0x1,(void*)0xffdf);
					if( (loc_838c != 0))
					{
						loc_838c = 0;
						sub_9241e();	
					}

					if( (storedCmdDiByte == 0xA8) ||	 
							(storedCmdDiByte == 0xD0) ||	 
							(storedCmdDiByte == 0xA4))
					{
						sub_838dc();	//this is dmaXferToWii 99% sure
						if(loc_8368 & 0x10)
						{
							loc_8368 &= 0xFFEF;
							sub_89e6c();
						}
					}
				}
			}
		}else{
			cmd0Flags = 0;
			asm("mov _cmd0Flags, a0");
			sub_94ec3(0x1,(void*)0xffff,0x1);
			cmd0Flags |= 0x80;
			cmd0Handler();
		}
	}
}

//This shit is here cause libgcc doesnt include it as it should.....
asm("
        .text
        .globl ___addsi3
        .type  ___addsi3,@function
___addsi3:
        add -4,a3
        movx d2,(0,a3)
        mov (8,a3),d2
        add d2,d0
        mov (10,a3),d2
        addc d2,d1
        movx (0,a3),d2
        add 4,a3
        rts
        .size ___addsi3,.-___addsi3

        .text
        .globl ___truncsipsi2_d0_d2
        .type  ___truncsipsi2_d0_d2,@function
___truncsipsi2_d0_d2:
        add -4,a3
        mov d0,(a3)
        mov d1,(2,a3)
        movx (0,a3),d2
        add 4,a3
        rts
        .size ___truncsipsi2_d0_d2,.-___truncsipsi2_d0_d2

        .text
        .globl ___prologue
        .type ___prologue,@function
___prologue:
        mov (0,a3),a0
        add -16,a3
        movx d2,(4,a3)
        movx d3,(8,a3)
        mov a1,(12,a3)
        mov a2,(16,a3)
        mov a0,(0,a3)
        rts
        .size ___prologue,.-___prologue

        .text
        .globl ___epilogue_noreturn
        .type ___epilogue_noreturn,@function
___epilogue_noreturn:
        movx (0,a3),d2
        movx (4,a3),d3
        mov (8,a3),a1
        mov (12,a3),a2
        add 16,a3
        rts
        .size ___epilogue_noreturn,.-___epilogue_noreturn

        .text
        .globl ___truncsipsi2_d0_d1
        .type  ___truncsipsi2_d0_d1,@function
___truncsipsi2_d0_d1:
        add -4,a3
        mov d0,(a3)
        mov d1,(2,a3)
        movx (0,a3),d1
        add 4,a3
        rts
        .size ___truncsipsi2_d0_d1,.-___truncsipsi2_d0_d1

");
