@echo off

echo **********************************************
echo ** OpenWii(2.2)-Auto-Flasher for ATMega8  **
echo **                                          **
echo ** by Rudi                                  **
echo** Updated by Triforce                  **
echo **********************************************
echo ** Credits: OpenWii-Team                    **
echo **                   @badzoo                **
echo **                         DeScRamBleR      **
echo **********************************************


:CHOOSE_CHIPSET
echo.
echo.
echo    First choose the chipset of your Wii !
set /P CHIPSET=           (A)=D2A/DMS, (B)=D2B 

if /I "%CHIPSET%"=="A" (
	avrdude -p m8 -c sp12 -U flash:w:openwii-dms-loader.hex  -U lfuse:w:0xE3:m  -U hfuse:w:0xDB:m
	goto CHOOSE_REGION
	)
if /I "%CHIPSET%"=="B" (
	avrdude -p m8 -c sp12 -U flash:w:openwii-d2b-loader.hex  -U lfuse:w:0xE3:m  -U hfuse:w:0xDB:m
	goto CHOOSE_REGION
	)
goto CHOOSE_CHIPSET

:CHOOSE_REGION
echo.
echo        Now choose Region of your Wii !
set /P REGION=           (P)AL, (U)SA, (J)AP 

if /I "%REGION%"=="P" (
	avrdude -p m8 -c sp12 -U eeprom:w:PAL.eep
        goto ENDE
        )
if /I "%REGION%"=="U" (
	avrdude -p m8 -c sp12 -U eeprom:w:USA.eep
        goto ENDE
        )
if /I "%REGION%"=="J" (
	avrdude -p m8 -c sp12 -U eeprom:w:JAP.eep
        goto ENDE
        )
goto CHOOSE_REGION

:ENDE
echo.
echo.
echo              DONE !
echo.
pause
